#ifndef LCD4_H
#define	LCD4_H
//------------------------------------------------------------------------------
#include <xc.h> 
#include "Lcd4_prototypes.h"
//-----------------------Follow Datasheet instructions--------------------------
void LCD_init()
{
  SCLK_dir = 0;
  SDOUT_dir = 0;
  STB_dir = 0;

  LCD_command(home);
  LCD_command(function_set);   
  LCD_command(display_on);      
  LCD_command(auto_increment);
}
//------------------------------------------------------------------------------
void LCD_command(char command)
{
  RS = 0;                         //Instruction register ( commands ).
  
  LCD_write(command & 0xF0);      //Higher Nible
  LCD_write(command << 4);        //Lower Nible
}
//------------------------------------------------------------------------------
void LCD_data(char data)
{
  RS = 1;                          //Data register ( Strings and characters ).
  
  LCD_write(data & 0xF0);    
  LCD_write(data << 4); 
}
//------------------------------------------------------------------------------
void LCD_string(char row, char column, char text[])
{
  LCD_command(rowAddr[row] + column);  //Set co-ordinates.
  while(*text)
  {
    LCD_data(*text++);
  }
}
//------------------------------------------------------------------------------
void LCD_character(char row, char column, char character)
{
  LCD_command(rowAddr[row] + column);
  LCD_data(character);
}
//------------------------------------------------------------------------------
void LCD_write(char data)
{
  data = (data | RS);
  
  //Enable is pulsed to latch the data
  LCD_serialTx(data | EN_high);
  __delay_us(5);
  LCD_serialTx(data & EN_low);
}
//------------------------------------------------------------------------------
void LCD_serialTx(unsigned char data)
{
  STB = 0; //Chip enabled
  
  for(int Tx = 0; Tx < 8; Tx++)
  {
   SCLK = 0;
   SDOUT = ((data << Tx) & 0x80) ? 1 : 0 ; // Transfer <Tx> byte MSB first.
   SCLK = 1;                               // Toggle the Serial Clock pin
  }
  
  STB = 1; //Chip disabled
}
//------------------------------------------------------------------------------
#endif